## gdb 6.8.50.20090417-0maemo2%2b0m5

=== gdb/features/Makefile ===
# Copyright (C) 2007, 2008, 2009 Free Software Foundation, Inc.

# This file is part of GDB.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.


# This file requires GNU make!

# This Makefile updates files in ../regformats from their XML master
# copies.  Because this relies on xsltproc, it is not normally run
# during the build process; it should be run by hand when one of the
# affected XML files is changed, and the results should be kept in the
# GDB repository.

# It can also update the C files in the features directory from their
# XML master copies.  This relies on a GDB linked with expat and
# configured for the correct architecture, so the files are again kept
# in the GDB repository.  To generate C files:
#   make GDB=/path/to/gdb XMLTOC="xml files" cfiles

WHICH = arm-with-iwmmxt mips-linux mips64-linux \
	rs6000/powerpc-32l rs6000/powerpc-altivec32l rs6000/powerpc-e500l \
	rs6000/powerpc-64l rs6000/powerpc-altivec64l rs6000/powerpc-vsx32l \
	rs6000/powerpc-vsx64l

# Record which registers should be sent to GDB by default after stop.
arm-with-iwmmxt-expedite = r11,sp,pc
mips-linux-expedite = r29,pc
mips64-linux-expedite = r29,pc
rs6000/powerpc-32l-expedite = r1,pc
rs6000/powerpc-altivec32l-expedite = r1,pc
rs6000/powerpc-vsx32l-expedite = r1,pc
rs6000/powerpc-isa205-32l-expedite = r1,pc
rs6000/powerpc-isa205-altivec32l-expedite = r1,pc
rs6000/powerpc-isa205-vsx32l-expedite = r1,pc
rs6000/powerpc-e500l-expedite = r1,pc
rs6000/powerpc-64l-expedite = r1,pc
rs6000/powerpc-altivec64l-expedite = r1,pc
rs6000/powerpc-vsx64l-expedite = r1,pc
rs6000/powerpc-isa205-64l-expedite = r1,pc
rs6000/powerpc-isa205-altivec64l-expedite = r1,pc
rs6000/powerpc-isa205-vsx64l-expedite = r1,pc


XSLTPROC = xsltproc
outdir = ../regformats
OUTPUTS = $(patsubst %,$(outdir)/%.dat,$(WHICH))

XMLTOC =
CFILES = $(patsubst %.xml,%.c,$(XMLTOC))
GDB = false

all: $(OUTPUTS)

$(outdir)/%.dat: %.xml number-regs.xsl sort-regs.xsl gdbserver-regs.xsl
	echo "# DO NOT EDIT: generated from $<" > $(outdir)/$*.tmp
	echo "name:`echo $(notdir $*) | sed 's/-/_/g'`" >> $(outdir)/$*.tmp
	echo "xmltarget:$(<F)" >> $(outdir)/$*.tmp
	echo "expedite:$($*-expedite)" >> $(outdir)/$*.tmp
	$(XSLTPROC) --path "$(PWD)" --xinclude number-regs.xsl $< | \
	  $(XSLTPROC) sort-regs.xsl - | \
	  $(XSLTPROC) gdbserver-regs.xsl - >> $(outdir)/$*.tmp
	sh ../../move-if-change $(outdir)/$*.tmp $(outdir)/$*.dat

cfiles: $(CFILES)
%.c: %.xml
	$(GDB) -nx -q -batch \
	  -ex "set tdesc filename $<" -ex 'maint print c-tdesc' > $@.tmp
	sh ../../move-if-change $@.tmp $@

# Other dependencies.
$(outdir)/arm-with-iwmmxt.dat: arm-core.xml xscale-iwmmxt.xml

=== gdb/testsuite/gdb.modula2/Makefile ===
# Makefile for regression testing the GNU debugger.
# Copyright 2007, 2008, 2009 Free Software Foundation, Inc.

# This file is part of GDB.

# GDB is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# GDB is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

VPATH = ../../.././gdb/testsuite/gdb.modula2
srcdir = ../../.././gdb/testsuite/gdb.modula2

EXECUTABLES = 

all info install-info dvi install uninstall installcheck check:
	@echo "Nothing to be done for $@..."

clean mostlyclean:
	-rm -f *~ *.o *.ci
	-rm -f core ${EXECUTABLES}

distclean maintainer-clean realclean: clean
	-rm -f Makefile config.status config.log

## gdb 6.4-osso2

=== debian/changelog ===
gdb (6.4-osso2) unstable; urgency=low

  * Added libncurses5-dev, flex and bison to build-dependency.

 -- Kalle Valo <Kalle.Valo@nokia.com>  Fri, 31 Mar 2006 16:39:09 +0300

gdb (6.4-osso1) unstable; urgency=low

  * Initial Release. Debianized completely from upstream sources to
    minimize build-dependencies.

 -- Kalle Valo <Kalle.Valo@nokia.com>  Fri, 31 Mar 2006 14:53:10 +0300

=== debian/control ===
Source: gdb
Section: unknown
Priority: optional
Maintainer: Kalle Valo <Kalle.Valo@nokia.com>
Build-Depends: debhelper (>= 4.0.0), libncurses5-dev, flex, bison
Standards-Version: 3.6.0

Package: gdb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The GNU Debugger for OSSO
 This is a (build-dependency) minimized GDB for OSSO usage.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

config.status: configure
	dh_testdir
	# Add here commands to configure the package.
	CFLAGS="$(CFLAGS)" ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info


build: build-stamp

build-stamp:  config.status
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	# Add here commands to clean up after the build process.
	-$(MAKE) distclean
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif


	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/tmp.
	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
#	dh_installexamples
	dh_install --sourcedir=debian/tmp
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
#	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## gdb 6.8-3maemo2

=== debian/changelog ===
gdb (6.8-3maemo2) unstable; urgency=low

  * disabled the use of tex and pdftex

 -- Juha Kallioinen <juha.kallioinen@nokia.com>  Wed, 14 Jan 2009 13:40:02 +0200

gdb (6.8-3maemo1) unstable; urgency=low

  * minimized build-deps for maemo
  * disabled PS document creation

 -- Juha Kallioinen <juha.kallioinen@nokia.com>  Wed, 10 Dec 2008 18:40:02 +0200

gdb (6.8-3) unstable; urgency=low

  * Initialize some uninitialized variables (Closes: #479561).
  * Drop gdb-arm and insight conflict/replace.
  * Fix build on m68k.

 -- Daniel Jacobowitz <dan@debian.org>  Wed, 07 May 2008 08:40:02 -0400

gdb (6.8-2) unstable; urgency=low

  * Make removal of stamp files the first action of the clean target
    (from Justin Pryzby).
  * Correct array access in ia64 port to fix build failure.
  * Fix GDB_TARGET support (reported by Fathi BOUDRA).
  * Update gcj build dependencies (Closes: #477863, #479111).
  * Add a man page for gcore, from Nicolas Bonifas (Closes: #479066).

 -- Daniel Jacobowitz <dan@debian.org>  Fri, 02 May 2008 18:28:37 -0400

gdb (6.8-1) unstable; urgency=low

  * New upstream release.
    - Remove patches merged upstream.
    - GDB automatically sets breakpoints in every copy of C++ templates
      and cloned constructors (Closes: #421540).
    - Improved support for debugging optimized code - local variables are
      displayed more often.
    - Automatically recognizes ObjC sources (Closes: #462882).
  * Backported patch to fix quoting for rbreak (Closes: #357319).
  * Adjust copyright file, quilt build dependency, and oldest changelog entry
    on lintian's advice.
  * Add libsim.a to libgdb-dev (Closes: #473295).

 -- Daniel Jacobowitz <dan@debian.org>  Thu, 27 Mar 2008 18:13:39 -0400

gdb (6.7.1-2) unstable; urgency=low

  * Add patch from Ulrich Weigand to fix stepping over shared library
  functions on PowerPC (Closes: #432461).
  * Add libgdb-dev package for fp-ide (Closes: #458250).
  * Avoid gcc-4.3 uninitialized warnings (Closes: #455669).
  * Updated Standards-Version to 3.7.3
    - Correct Apps -> Applications in gdb.menu.

 -- Daniel Jacobowitz <dan@debian.org>  Wed, 02 Jan 2008 08:49:43 -0500

gdb (6.7.1-1) unstable; urgency=low

  * New upstream release.
    - Correct makeinfo version check (Closes: #453202).
  * Merge Ubuntu support for a gdb64 package (Closes: #254270).
  * Run the testsuite on all GNU/Linux platforms.
  * Remove old support for skipping thread tests.
  * Add an expat build dependency and add --with-expat.
  * Update copyright notice.
  * Do not freeze on division by zero (Closes: #414887).
  * Rewrite HPPA kernel offsets patch to support HPPA64.
  * Include Vladimir Prus's varobj fix for kdevelop (Closes: #443080).

 -- Daniel Jacobowitz <dan@debian.org>  Mon, 03 Dec 2007 10:12:27 -0500

gdb (6.6.dfsg.90.20070912-1) unstable; urgency=low

  * New upstream snapshot (pre-release for GDB 6.7).
    - Patches 10.selected-frame.patch, dwarf2-long-size.patch merged upstream.
    - Backports unwind-check-pc-regnum.patch, ia64-unwind-signedness.patch
      removed.
    - Patch 13.use-dynamic-readline.patch replaced by
      --with-system-readline.
    - Patch sim-destdir.patch unnecessary.
  * Disable gcj and gobjc build dependencies for armel (Closes: #441741).
  * Replace tetex-bin build dependency with texlive-base.
  * Include kernel offsets for HPPA.

 -- Daniel Jacobowitz <dan@debian.org>  Sat, 15 Sep 2007 13:40:34 -0400

gdb (6.6.dfsg-3) unstable; urgency=low

  * Correct signedness error in ia64-tdep.c (Closes: #423631) (again).

 -- Daniel Jacobowitz <dan@debian.org>  Fri, 24 Aug 2007 15:48:11 -0400

gdb (6.6.dfsg-2) unstable; urgency=low

  * Check PC_REGNUM before using it (Closes: #423631).

 -- Daniel Jacobowitz <dan@debian.org>  Thu, 23 Aug 2007 22:26:20 -0400

gdb (6.6.dfsg-1) unstable; urgency=low

  [ Matthias Klose ]
  * New upstream version.
    - Prints a newline after EOF (Closes: #233467).
  * sim-destdir.patch, gdbinit-ownership.patch, bfd-get-mtime-less.patch,
    pie-support.patch, thread-db-multiple-libraries.patch: Update.
  * thread-db-live-threads.patch, fork-context-switch.patch: Remove,
    applied upstream.

  [ Daniel Jacobowitz ]
  * Merge changes from Matthias Klose (thanks).
  * Refresh all patches.
  * Fix "corrupted DWARF expression" error (Closes: #405116).
  * Do not crash if loading libthread_db failed (Closes: #408402).
  * Initial support for building cross-GDB packages, based on the work of
    Raphael Bossek and Kazuhiro Inaoka (Closes: #313340, #343419, #373927).
  * Change priority to optional (since ftpmaster did).

 -- Daniel Jacobowitz <dan@debian.org>  Sat, 27 Jan 2007 21:59:06 -0500

gdb (6.5.dfsg-2) unstable; urgency=low

  * Backport a patch to fix GDB segfaults on threaded programs.
  * Backport a patch to fix errors on fork/vfork in threaded programs.

 -- Daniel Jacobowitz <dan@debian.org>  Thu, 16 Nov 2006 11:06:50 -0500

gdb (6.5.dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #386586).
  * Update Standards-Version to 3.7.2 (no changes required).
  * Mention --args in the man page (Closes: #394150).
  * Mention gdbtui and -tui (Closes: #362795).
  * Correctly detect changed executables when rerunning.

 -- Daniel Jacobowitz <dan@debian.org>  Sun,  5 Nov 2006 18:33:48 -0500

gdb (6.4.90.dfsg-1) unstable; urgency=low

  * New upstream snapshot (GDB 6.5 prerelease).
    - BFD build fix for GCC 4.2 (Closes: #364124).
    - xstrvprintf error message corrected (Closes: #296483).
    - Rewritten printf command (Closes: #186037, #231162).
    - Build fix for hurd-i386 (Closes: #345108).
  * Split the GDB package into DFSG and non-DFSG portions (Closes: #212522).
    The documentation has been moved to the new gdb-doc package, which
    this one Suggests.
    - Remove packaging for info files.
    - Remove GFDL section from debian/copyright.
    - Update README.Debian.
  * Correct control.in to also use libreadline5-dev.
  * Update type-handling usage.


=== debian/control ===
Source: gdb
Maintainer: Daniel Jacobowitz <dan@debian.org>
Section: devel
Priority: optional
Standards-Version: 3.7.3
Build-Depends: autoconf, libtool, texinfo (>= 4.7-2.2), libncurses5-dev, libreadline4-dev, bison, gettext, debhelper (>= 4.9.0), cdbs (>= 0.4.17), quilt (>= 0.30), flex | flex-old, libexpat1-dev

Package: gdb
Architecture: any
Section: devel
Depends: ${shlibs:Depends}
Suggests: gdb-doc
Description: The GNU Debugger
 GDB is a source-level debugger, capable of breaking programs at
 any specific line, displaying variable values, and determining
 where errors occurred. Currently, it works for C, C++, Fortran,
 Modula 2 and Java programs. A must-have for any serious
 programmer.

Package: libgdb-dev
Architecture: any
Section: libdevel
Priority: extra
Description: The GNU Debugger (libgdb.a)
 GDB is a source-level debugger, capable of breaking programs at
 any specific line, displaying variable values, and determining
 where errors occurred. Currently, it works for C, C++, Fortran
 Modula 2 and Java programs. A must-have for any serious
 programmer.
 .
 This package contains libgdb.a, the bulk of GDB as a linkable
 library.  It is provided for an IDE which links to libgdb.a.  Please
 do not use libgdb.a for new projects.

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILDDIR := $(shell pwd)/objdir
DEB_DH_INSTALL_SOURCEDIR := $(shell pwd)/debian/tmp

# This implements the .deb package creation using debhelper.
include /usr/share/cdbs/1/rules/debhelper.mk

# This implements building using a configure script and Makefile.
include /usr/share/cdbs/1/class/autotools.mk

# Quilt-based patches in debian/patches.
include /usr/share/cdbs/1/rules/patchsys-quilt.mk

# Override CDBS's default CFLAGS, which also includes -Wall; gdb
# does not handle -Wunused well with -Werror, but defaults to
# -Werror.
CFLAGS = -g $(DEB_OPT_FLAG)

# Always install into debian/tmp, even if we are only building one package.
DEB_DESTDIR := $(shell pwd)/debian/tmp

install = /usr/bin/install -p

# Rather paranoid than sorry. Make the shell exit with an error if an
# untested command fails.
SHELL += -e

DEB_HOST_GNU_SYSTEM := $(shell dpkg-architecture -qDEB_HOST_GNU_SYSTEM)
DEB_HOST_GNU_CPU := $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_GNU_TYPE := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

# Cross configuration support.  Check for an environment variable
# $GDB_TARGET, or a file debian/target.
ifndef GDB_TARGET
DEBIAN_TARGET_FILE := $(strip $(shell cat debian/target 2>/dev/null))
ifneq ($(DEBIAN_TARGET_FILE),)
GDB_TARGET := $(DEBIAN_TARGET_FILE)
endif
endif

DEB_TARGET_ARCH	:= $(shell dpkg-architecture -f \
		     -a$(GDB_TARGET) -qDEB_HOST_ARCH 2>/dev/null)
DEB_TARGET_GNU_TYPE := $(shell dpkg-architecture -f \
			 -a$(DEB_TARGET_ARCH) -qDEB_HOST_GNU_TYPE 2>/dev/null)
DEB_TARGET_ALIAS ?= $(DEB_TARGET_GNU_TYPE)

ifeq ($(DEB_TARGET_ARCH),)
$(error GDB_TARGET value "$(GDB_TARGET)" is not a valid Debian architecture)
endif

ifdef GDB_TARGET
  DEB_CROSS = yes
  # TP: Target Prefix. Used primarily as a prefix for cross tool
  #     names (e.g. powerpc-linux-gcc).
  # TS: Target Suffix. Used primarily at the end of cross compiler
  #     package names (e.g. gcc-powerpc).
  TP = $(DEB_TARGET_ALIAS)-
  TS = -$(DEB_TARGET_ALIAS)
  CROSS_FORCE = FORCE
else
ifneq (,$(filter $(DEB_HOST_ARCH),i386 powerpc sparc s390))
  build64 = no
  CC64 = gcc -m64
  CFLAGS64 = $(CFLAGS)
  BUILDDIR64 = objdir64
  ifeq ($(DEB_HOST_ARCH),i386)
    HOST64 = x86_64-linux-gnu
  endif
  ifeq ($(DEB_HOST_ARCH),powerpc)
    HOST64 = powerpc64-linux-gnu
  endif
  ifeq ($(DEB_HOST_ARCH),sparc)
    HOST64 = sparc64-linux-gnu
  endif
  ifeq ($(DEB_HOST_ARCH),s390)
    HOST64 = s390x-linux-gnu
  endif
endif
endif

run_tests := yes

ifneq ($(DEB_HOST_GNU_SYSTEM),linux-gnu)
  run_tests := no
endif

ifeq ($(DEB_HOST_GNU_CPU),ia64)
  arch_config_args := --with-libunwind
endif

ifdef GDB_TARGET
  run_tests := no

  arch_config_args += --program-prefix=$(TP) \
    --target=$(DEB_TARGET_ALIAS) --with-sysroot=/usr/$(DEB_TARGET_ALIAS)
endif

INSTALL = $(install)
export INSTALL

# We pass srcdir explicitly to avoid an extra '/.' at the end of it.  That
# causes a harmless, but ugly, testsuite failure in maint.exp.
EXTRA_FLAGS := --disable-gdbtk --disable-shared --enable-tui \
	--srcdir=$(shell pwd) --with-system-readline \
	$(arch_config_args) --build=$(DEB_HOST_GNU_TYPE)

# Debian does not include 64-bit expat packages yet, so --with-expat
# is here rather than in EXTRA_FLAGS.
DEB_CONFIGURE_EXTRA_FLAGS := --host=$(DEB_HOST_GNU_TYPE) $(EXTRA_FLAGS) \
	--with-expat

DEB_MAKE_BUILD_TARGET = all info

post-patches::
	if ! test -f gdb/version.in.backup; then \
	  mv -f gdb/version.in gdb/version.in.backup; \
	  sed -e 's/$$/-debian/' < gdb/version.in.backup > gdb/version.in; \
	fi

# This should probably be common-post-build-arch, but that runs during
# install, under fakeroot, in CDBS 0.4.21.
build/gdb$(TS):: check-stamp
	$(MAKE) -C objdir/gdb/doc refcard.dvi refcard.ps

build/gdb64:: build64-stamp

build64-stamp:
	mkdir -p $(BUILDDIR64)
	cd $(BUILDDIR64) && CC="$(CC64)" CFLAGS="$(CFLAGS64)" AR=ar \
	  ../configure $(EXTRA_FLAGS) --host=$(HOST64)
	cd $(BUILDDIR64) && $(MAKE)
	touch $@

check-stamp:
ifeq ($(run_tests),yes)
	-ulimit -c unlimited; \
	$(MAKE) -C objdir/gdb check \
		2>&1 | tee objdir/check.log
endif
	touch $@

clean::
	rm -f check-stamp build64-stamp
	rm -rf objdir $(BUILDDIR64)

	if test -f gdb/version.in.backup; then \
	  mv -f gdb/version.in.backup gdb/version.in; \
	fi

#	# For snapshots this is appropriate; careful of release tarballs
#	# which include .gmo files.
#	find -type f -name '*.gmo' | xargs rm -f

	# Prevent gratuitous rebuilds of the BFD documentation, since it
	# updates the copy in the source directory.
	find bfd -name bfd.info\* | xargs --no-run-if-empty touch

binary-post-install/gdb$(TS) ::
	if [ -x debian/tmp/usr/bin/run ]; then				\
		mv debian/tmp/usr/bin/run					\
		  debian/gdb$(TS)/usr/bin/$(DEB_TARGET_ALIAS)-run;		\
		mv debian/tmp/usr/share/man/man1/run.1			\
		  debian/gdb$(TS)/usr/share/man/man1/$(DEB_TARGET_ALIAS)-run.1;	\
	fi
ifeq ($(run_tests),yes)
	install -d debian/gdb$(TS)/usr/share/doc/gdb
	install -m 644 objdir/check.log \
		debian/gdb$(TS)/usr/share/doc/gdb/check.log
endif

ifneq ($(DEB_CROSS),yes)
	# Gcore is only useful for native GDB.
	$(INSTALL) -m 755 -o root -g root \
		gdb/gdb_gcore.sh debian/gdb$(TS)/usr/bin/$(TP)gcore
endif

ifeq ($(build64),yes)
	install -d debian/gdb64/usr/bin
	install -s -m 755 $(BUILDDIR64)/gdb/gdb debian/gdb64/usr/bin/gdb64
	dh_link -pgdb64 usr/share/man/man1/gdb.1 usr/share/man/man1/gdb64.1
endif

	rm -rf debian/tmp/usr/include \
		debian/tmp/usr/lib/lib*.* \
		debian/tmp/usr/share/locale

	# Remove the entire info directory; it only contains dummy files,
	# not the real manuals.
	rm -rf debian/tmp/usr/share/info

ifneq ($(DEB_CROSS),yes)
	# libgdb-dev is only required for native GDB.
	install -d debian/tmp/usr/lib
	install -m 644 $(DEB_BUILDDIR)/gdb/libgdb.a debian/tmp/usr/lib/
	if test -e $(DEB_BUILDDIR)/sim/*/libsim.a; then \
	  install -m 644 $(DEB_BUILDDIR)/sim/*/libsim.a debian/tmp/usr/lib/; \
	fi
endif

debian/control:: debian/control.in $(CROSS_FORCE)
	cat debian/control.in \
		| sed "s/@kfreebsd@/`type-handling any kfreebsd`/g" \
		| sed "s/@gnu@/`type-handling any gnu`/g" \
		| sed "s/@TS@/$(TS)/g" \
		> debian/control
ifeq ($(DEB_CROSS),yes)
	sed -i "/Package: gdb64/,\$$ d" debian/control
	cp debian/gdb.install debian/gdb$(TS).install
endif

DEB_INSTALL_DOCS_gdb$(TS) = gdb/NEWS gdb/README gdb/doc/refcard.tex \
		objdir/gdb/doc/refcard.dvi objdir/gdb/doc/refcard.ps
DEB_INSTALL_CHANGELOGS_gdb$(TS) = gdb/ChangeLog
DEB_INSTALL_MANPAGES_gdb$(TS) = gdb/gdb.1
ifneq ($(DEB_CROSS),yes)
DEB_INSTALL_MANPAGES_gdb$(TS) += debian/gcore.1
endif

DEB_INSTALL_DOCS_libgdb-dev = gdb/NEWS gdb/README
DEB_INSTALL_CHANGELOGS_libgdb-dev = gdb/ChangeLog

.PHONY: FORCE
FORCE:

## gdb 6.8.50.20090417-0maemo2%2b0m5

=== debian/changelog ===
gdb (6.8.50.20090417-0maemo2+0m5) experimental; urgency=low

  * This entry has been added by BIFH queue processor
    Suffix +0m5 added to package revision

 -- Juha Kallioinen <juha.kallioinen@nokia.com>  Wed, 24 Jun 2009 16:46:00 +0300

gdb (6.8.50.20090417-0maemo2) experimental; urgency=low

  * Disabled building gdbtui to save some space.

 -- Juha Kallioinen <juha.kallioinen@nokia.com>  Wed, 24 Jun 2009 16:35:57 +0300

gdb (6.8.50.20090417-0maemo1+0m5) experimental; urgency=low

  * This entry has been added by BIFH queue processor
    Suffix +0m5 added to package revision

 -- Juha Kallioinen <juha.kallioinen@nokia.com>  Tue, 21 Apr 2009 12:20:57 +0300

gdb (6.8.50.20090417-0maemo1) experimental; urgency=low

  * CVS snapshot from 2009-04-17
  * Debianization from Debian experimental
  * Disabled python support
  * Fixed ARM CPSR register index in gdb/arm-tdep.h
  * Fixes: NB#10979
  * Fixes: NB#95835
  * Fixes: NB#110688

 -- Juha Kallioinen <juha.kallioinen@nokia.com>  Mon, 20 Apr 2009 15:24:56 +0300

gdb (6.8.50.20090116.python-1+0maemo1+0m5) experimental; urgency=low

  * This entry has been added by BIFH queue processor
    Suffix +0m5 added to package revision

 -- Juha Kallioinen <juha.kallioinen@nokia.com>  Fri, 03 Apr 2009 11:32:56 +0300

gdb (6.8.50.20090116.python-1+0maemo1) experimental; urgency=low

  * Integrated for Fremantle
  * Does not build python support or 64 bit binaries
  * Fixes: NB#95835

 -- Juha Kallioinen <juha.kallioinen@nokia.com>  Fri, 03 Apr 2009 11:24:41 +0300

gdb (6.8.50.20090116.python-1) experimental; urgency=low

  * New snapshot from archer-tromey-python branch.
  * Make sure that Python is enabled for the main gdb package.

 -- Daniel Jacobowitz <dan@debian.org>  Fri, 12 Dec 2008 11:30:41 -0500

gdb (6.8.50.20081210.python-1) experimental; urgency=low

  * New snapshot from archer-tromey-python branch.

 -- Daniel Jacobowitz <dan@debian.org>  Wed, 10 Dec 2008 21:36:26 -0500

gdb (6.8.50.20081120.python-1) experimental; urgency=low

  * Package archer-tromey-python branch for experimental.  Highlights since
    GDB 6.8 (for more, see the NEWS file):
    - Python scripting support.  This is experimental; the interfaces
      are subject to change.  Some example scripts are packaged, including
      STL pretty-printers for libstdc++.
    - Improved preprocessor macro support.
    - Non-stop debugging support (for 32-bit i386 only).  You can stop just
      one thread of interest while the others continue to run.
    - Improved tab completion, including C structure fields.
    - Faster remote debugging.
    - Compressed debug information support; the new "gold" linker can generate
      compressed debug sections.
    - New "find" command to search memory.
  * Build depend on zlib1g-dev and python-dev.
  * Removed bfd-get-mtime-less.patch, gdb-rbreak-quoting.patch,
  ia64-array-bound.patch, cp-support-uninit.patch,
  and m68k-nat-build-fix.patch, merged upstream.
  * Build depend on procps for testsuite cleanup calls to "kill".
  * Remove use of -p0 in series file (Closes: #484945).
	
 -- Daniel Jacobowitz <dan@debian.org>  Fri, 28 Nov 2008 14:28:47 -0500

=== debian/rules ===
--- 
+++ 
@@ -101,14 +101,14 @@
 
 # We pass srcdir explicitly to avoid an extra '/.' at the end of it.  That
 # causes a harmless, but ugly, testsuite failure in maint.exp.
-EXTRA_FLAGS := --disable-gdbtk --disable-shared --enable-tui \
+EXTRA_FLAGS := --disable-gdbtk --disable-shared --disable-tui \
 	--srcdir=$(shell pwd) --with-system-readline \
 	$(arch_config_args) --build=$(DEB_HOST_GNU_TYPE)
 
 # Debian does not include 64-bit expat packages yet, so --with-expat
-# is here rather than in EXTRA_FLAGS.
+# is here rather than in EXTRA_FLAGS.  Similarly Python.
 DEB_CONFIGURE_EXTRA_FLAGS := --host=$(DEB_HOST_GNU_TYPE) $(EXTRA_FLAGS) \
-	--with-expat
+	--with-expat --without-python --disable-werror
 
 DEB_MAKE_BUILD_TARGET = all info

## gdb 7.0.1

=== debian/changelog ===
gdb (7.0.1-2) unstable; urgency=low

  * Add Replaces to the new gdbserver package (Closes: #567925, #568018).
  * Add patch to fix FreeBSD build (Closes: #561924).

 -- Daniel Jacobowitz <dan@debian.org>  Tue, 02 Feb 2010 14:59:41 -0500

gdb (7.0.1-1) unstable; urgency=low

  * New upstream release.
  * Avoid hardcoded "debian" in the binary using lsb_release (from
    Matthias Klose).
  * Use DEB_MAKE_ENVVARS for 64-bit builds also (from Matthias Klose).
  * Build depend on gcj-jdk | gcj (from Matthias Klose).
  * Add gdb-source package (Closes: #550755).
  * Move gdbserver into its own package (Closes: #562651).
  * Add gdb-minimal package (Closes: #560786).
  * Update to Standards-Version: 3.8.3.
  * Package /usr/share/gdb.
  * Switch to 3.0 (quilt) source package format.

 -- Daniel Jacobowitz <dan@debian.org>  Sat, 30 Jan 2010 15:16:35 -0500

gdb (7.0-1) unstable; urgency=low

  * New upstream release (Closes: #550567).
  * Order options alphabetically in the man page (Closes: #540811).

 -- Daniel Jacobowitz <dan@debian.org>  Sun, 11 Oct 2009 17:16:26 -0400

gdb (6.8.50.20090628-4) unstable; urgency=low

  * Mention online documentation in README.Debian (Closes: #537795).
  * Fix GNU/Hurd support (Closes: #539351).
  * Depend on libreadline-dev and lib64readline6-dev.

 -- Daniel Jacobowitz <dan@debian.org>  Mon, 14 Sep 2009 16:17:50 -0400

gdb (6.8.50.20090628-3) unstable; urgency=low

  * Remove stray "set -x" from gdbtui script.

 -- Daniel Jacobowitz <dan@debian.org>  Mon, 13 Jul 2009 16:49:41 -0400

gdb (6.8.50.20090628-2) unstable; urgency=low

  * Re-enable gobjc testing on armel (Closes: #497161).
  * Do not install an extra copy of the GDB man page in cross-debugger
    packages (Closes: #492846).
  * Add i386 %ebp backtrace patch from Michael Matz (Closes: #498030).
    This improves backtraces on 32-bit programs with missing debug info
    for some functions on the stack.
  * Replace the separate gdbtui binary with a shell script (suggested
    by Matthias Klose).
  * Support parallel=<n> in DEB_BUILD_OPTIONS (from Matthias Klose).
  * Support nocheck in DEB_BUILD_OPTIONS (from Matthias Klose).
  * Run the testsuite on linux-gnueabi and linux-gnulp systems also
    (from Matthias Klose).
  * Package the DejaGNU .sum file instead of part of the build log.
    It's bigger, but more useful (especially with parallel=).

 -- Daniel Jacobowitz <dan@debian.org>  Mon, 06 Jul 2009 14:52:31 -0400

gdb (6.8.50.20090628-1) unstable; urgency=low

  * New snapshot from trunk.  The experimental packages used the
    archer-tromey-python branch; the whole branch has not been merged
    to trunk, but significant portions of it have, and will be in GDB 7.
    So this includes some Python scripting support.  Other highlights
    since the last experimental package:
    - Reverse debugging commands.  With a remote target that supports
      reverse debugging, you can step backwards as easily as forwards.
    - Process record and replay, a native Linux implementation of
      reverse debugging.  Only 32-bit IA32 Linux is currently supported.
    - MIPS/Linux hardware watchpoint support.
    - Multi-byte and wide character set support, including wchar_t display.
    - Inlined function support, including in backtrace and step/next/finish.
    - Improved C++ template name parsing.
    - Non-stop debugging (some threads remain running while others
      are stopped in the debugger).  Only implemented so far for i386,
      x86-64, and powerpc.
    - A bug fix for discontiguous code, e.g. as found in the Linux kernel
      (Closes: #513816).
    - A build fix that affected SPARC (Closes: #512121).
    - A build fix for casts on hurd-i386 (Closes: #494839).
    - A fix for debugging multi-threaded programs that call exec, including
      Eclipse with the Sun JVM (Closes: #490046).
  * Removed thread-db-multiple-libraries.patch.  This let one GDB work with
    both LinuxThreads and NPTL, but no Debian platform has both now.
  * GDB now reads /etc/gdb/gdbinit at startup (Closes: #33187).
  * Ship required libraries (libbfd, libopcodes, and libiberty) in
    /usr/lib/gdb in the libgdb-dev package, in case binutils-dev's versions
    are not close enough (Closes: #509873).
  * Add dev package dependencies to libgdb-dev.

 -- Daniel Jacobowitz <dan@debian.org>  Sun, 05 Jul 2009 16:25:07 -0400

gdb (6.8.50.20090519.python-1) experimental; urgency=low

  * New snapshot from archer-tromey-python branch.
  * Update debhelper compatibility level to 7.
  * Update to Standards-Version: 3.8.1.

 -- Daniel Jacobowitz <dan@debian.org>  Thu, 04 Jun 2009 09:38:13 -0400

=== debian/control ===
Source: gdb
Maintainer: Daniel Jacobowitz <dan@debian.org>
Section: devel
Priority: optional
Standards-Version: 3.8.3
Build-Depends: autoconf, libtool, texinfo (>= 4.7-2.2), texlive-base, libncurses5-dev, libreadline-dev, bison, gettext, debhelper (>= 7), dejagnu, gcj-jdk | gcj, gobjc, mig [hurd-alpha hurd-amd64 hurd-arm hurd-armeb hurd-avr32 hurd-hppa hurd-i386 hurd-ia64 hurd-m32r hurd-m68k hurd-mips hurd-mipsel hurd-powerpc hurd-ppc64 hurd-s390 hurd-s390x hurd-sh3 hurd-sh3eb hurd-sh4 hurd-sh4eb hurd-sparc], cdbs (>= 0.4.17), libkvm-dev [kfreebsd-alpha kfreebsd-amd64 kfreebsd-arm kfreebsd-armeb kfreebsd-avr32 kfreebsd-hppa kfreebsd-i386 kfreebsd-ia64 kfreebsd-m32r kfreebsd-m68k kfreebsd-mips kfreebsd-mipsel kfreebsd-powerpc kfreebsd-ppc64 kfreebsd-s390 kfreebsd-s390x kfreebsd-sh3 kfreebsd-sh3eb kfreebsd-sh4 kfreebsd-sh4eb kfreebsd-sparc], type-handling (>= 0.2.1), libunwind7-dev [ia64], flex | flex-old, libexpat1-dev, g++-multilib [i386 powerpc s390 sparc], lib64readline6-dev [i386 powerpc s390 sparc], python-dev, zlib1g-dev, procps, lsb-release, bzip2

Package: gdb
Architecture: any
Section: devel
Depends: ${shlibs:Depends}, ${misc:Depends}, gdbserver [amd64 armel i386 ia64 mips mipsel powerpc s390]
Suggests: gdb-doc
Description: The GNU Debugger
 GDB is a source-level debugger, capable of breaking programs at
 any specific line, displaying variable values, and determining
 where errors occurred. Currently, it works for C, C++, Fortran,
 Modula 2 and Java programs. A must-have for any serious
 programmer.

Package: gdb-minimal
Architecture: any
Section: devel
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: gdb
Description: The GNU Debugger
 GDB is a source-level debugger, capable of breaking programs at
 any specific line, displaying variable values, and determining
 where errors occurred. Currently, it works for C, C++, Fortran,
 Modula 2 and Java programs. A must-have for any serious
 programmer.
 .
 This package contains a minimal version of GDB with optional features
 disabled.

Package: gdb64
Architecture: i386 powerpc s390 sparc
Section: devel
Depends: ${shlibs:Depends}, gdb, ${misc:Depends}
Description: The GNU Debugger (64-bit)
 GDB is a source-level debugger, capable of breaking programs at
 any specific line, displaying variable values, and determining
 where errors occurred. Currently, it works for C, C++, Fortran
 Modula 2 and Java programs. A must-have for any serious
 programmer.

Package: gdbserver
Architecture: amd64 armel i386 ia64 mips mipsel powerpc s390
Section: devel
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: gdb (<< 7.0.1-1)
Description: The GNU Debugger (remote server)
 GDB is a source-level debugger, capable of breaking programs at
 any specific line, displaying variable values, and determining
 where errors occurred. Currently, it works for C, C++, Fortran
 Modula 2 and Java programs. A must-have for any serious
 programmer.
 .
 This package contains gdbserver.  Install this to debug remotely
 from another system where GDB is installed.

Package: libgdb-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, binutils-dev, libexpat1-dev, python-dev, zlib1g-dev, libncurses5-dev, libreadline-dev
Priority: extra
Description: The GNU Debugger (libgdb.a)
 GDB is a source-level debugger, capable of breaking programs at
 any specific line, displaying variable values, and determining
 where errors occurred. Currently, it works for C, C++, Fortran
 Modula 2 and Java programs. A must-have for any serious
 programmer.
 .
 This package contains libgdb.a, the bulk of GDB as a linkable
 library.  It is provided for an IDE which links to libgdb.a.  Please
 do not use libgdb.a for new projects.

Package: gdb-source
Architecture: all
Section: devel
Depends: ${misc:Depends}
Description: The GNU Debugger (source)
 GDB is a source-level debugger, capable of breaking programs at
 any specific line, displaying variable values, and determining
 where errors occurred. Currently, it works for C, C++, Fortran
 Modula 2 and Java programs. A must-have for any serious
 programmer.
 .
 This package contains the sources and patches which are needed
 to build GDB.

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #!/usr/bin/make -f
 
-DEB_BUILDDIR := $(shell pwd)/objdir
+ALL_BUILDDIR := $(shell pwd)/build
+
+DEB_BUILDDIR := $(ALL_BUILDDIR)/objdir
 DEB_DH_INSTALL_SOURCEDIR := $(shell pwd)/debian/tmp
 
 # This implements the .deb package creation using debhelper.
@@ -8,9 +10,6 @@
 
 # This implements building using a configure script and Makefile.
 include /usr/share/cdbs/1/class/autotools.mk
-
-# Quilt-based patches in debian/patches.
-include /usr/share/cdbs/1/rules/patchsys-quilt.mk
 
 # Override CDBS's default CFLAGS, which also includes -Wall; gdb
 # does not handle -Wunused well with -Werror, but defaults to
@@ -60,10 +59,10 @@
   CROSS_FORCE = FORCE
 else
 ifneq (,$(filter $(DEB_HOST_ARCH),i386 powerpc sparc s390))
-  build64 = no
+  build64 = yes
   CC64 = gcc -m64
   CFLAGS64 = $(CFLAGS)
-  BUILDDIR64 = objdir64
+  BUILDDIR64 = $(ALL_BUILDDIR)/objdir64
   ifeq ($(DEB_HOST_ARCH),i386)
     HOST64 = x86_64-linux-gnu
   endif
@@ -81,7 +80,11 @@
 
 run_tests := yes
 
-ifneq ($(DEB_HOST_GNU_SYSTEM),linux-gnu)
+ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
+  run_tests := no
+endif
+
+ifeq (,$(findstring linux, $(DEB_HOST_GNU_SYSTEM)))
   run_tests := no
 endif
 
@@ -94,6 +97,10 @@
 
   arch_config_args += --program-prefix=$(TP) \
     --target=$(DEB_TARGET_ALIAS) --with-sysroot=/usr/$(DEB_TARGET_ALIAS)
+else
+  # To avoid file conflicts, only enable the global gdbinit file for native
+  # debuggers.
+  arch_config_args += --with-system-gdbinit=/etc/gdb/gdbinit
 endif
 
 INSTALL = $(install)
@@ -101,48 +108,73 @@
 
 # We pass srcdir explicitly to avoid an extra '/.' at the end of it.  That
 # causes a harmless, but ugly, testsuite failure in maint.exp.
-EXTRA_FLAGS := --disable-gdbtk --disable-shared --disable-tui \
+EXTRA_FLAGS := --disable-gdbtk --disable-shared \
 	--srcdir=$(shell pwd) --with-system-readline \
 	$(arch_config_args) --build=$(DEB_HOST_GNU_TYPE)
 
 # Debian does not include 64-bit expat packages yet, so --with-expat
 # is here rather than in EXTRA_FLAGS.  Similarly Python.
 DEB_CONFIGURE_EXTRA_FLAGS := --host=$(DEB_HOST_GNU_TYPE) $(EXTRA_FLAGS) \
-	--with-expat --without-python --disable-werror
-
-DEB_MAKE_BUILD_TARGET = all info
+	--enable-tui --with-expat --with-python
+
+# 64-bit flags
+DEB_CONFIGURE_FLAGS_64 := --host=$(HOST64) $(EXTRA_FLAGS) \
+	--enable-tui
+
+# Minimal flags
+DEB_CONFIGURE_FLAGS_MIN := --host=$(DEB_HOST_GNU_TYPE) $(EXTRA_FLAGS) \
+	--disable-tui --without-expat --without-python
+
+# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
+COMMA = ,
+ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
+  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
+endif
+
+DEB_MAKE_BUILD_TARGET = $(NJOBS) all
+distribution := $(shell lsb_release -is | tr A-Z a-z)
+
+BUILDDIRSOURCE := $(ALL_BUILDDIR)/gdb
+BUILDDIRMIN := $(ALL_BUILDDIR)/gdb-minimal
 
 post-patches::
 	if ! test -f gdb/version.in.backup; then \
 	  mv -f gdb/version.in gdb/version.in.backup; \
-	  sed -e 's/$$/-debian/' < gdb/version.in.backup > gdb/version.in; \
+	  sed -e 's/$$/-$(distribution)/' < gdb/version.in.backup > gdb/version.in; \
 	fi
 
 # This should probably be common-post-build-arch, but that runs during
 # install, under fakeroot, in CDBS 0.4.21.
 build/gdb$(TS):: check-stamp
-	$(MAKE) -C objdir/gdb/doc refcard.dvi refcard.ps
+	$(MAKE) -C $(DEB_BUILDDIR) info
+	$(MAKE) -C $(DEB_BUILDDIR)/gdb/doc refcard.dvi refcard.ps
 
 build/gdb64:: build64-stamp
-
 build64-stamp:
 	mkdir -p $(BUILDDIR64)
 	cd $(BUILDDIR64) && CC="$(CC64)" CFLAGS="$(CFLAGS64)" AR=ar \
-	  ../configure $(EXTRA_FLAGS) --host=$(HOST64)
-	cd $(BUILDDIR64) && $(MAKE)
+	  $(shell pwd)/configure $(DEB_CONFIGURE_FLAGS_64)
+	cd $(BUILDDIR64) && $(DEB_MAKE_ENVVARS) $(MAKE) $(NJOBS)
+	touch $@
+
+build/gdb-minimal:: build-minimal-stamp
+build-minimal-stamp:
+	mkdir -p $(BUILDDIRMIN)
+	cd $(BUILDDIRMIN) && \
+	  $(shell pwd)/configure $(DEB_CONFIGURE_FLAGS_MIN)
+	cd $(BUILDDIRMIN) && $(DEB_MAKE_ENVVARS) $(MAKE) $(NJOBS)
 	touch $@
 
 check-stamp:
 ifeq ($(run_tests),yes)
 	-ulimit -c unlimited; \
-	$(MAKE) -C objdir/gdb check \
-		2>&1 | tee objdir/check.log
+	$(MAKE) $(NJOBS) -C $(DEB_BUILDDIR)/gdb check
 endif
 	touch $@
 
 clean::
 	rm -f check-stamp build64-stamp
-	rm -rf objdir $(BUILDDIR64)
+	rm -rf $(ALL_BUILDDIR)
 
 	if test -f gdb/version.in.backup; then \
 	  mv -f gdb/version.in.backup gdb/version.in; \
@@ -165,7 +197,7 @@
 	fi
 ifeq ($(run_tests),yes)
 	install -d debian/gdb$(TS)/usr/share/doc/gdb
-	install -m 644 objdir/check.log \
+	install -m 644 $(DEB_BUILDDIR)/gdb/testsuite/gdb.sum \
 		debian/gdb$(TS)/usr/share/doc/gdb/check.log
 endif
 
@@ -173,52 +205,49 @@
 	# Gcore is only useful for native GDB.
 	$(INSTALL) -m 755 -o root -g root \
 		gdb/gdb_gcore.sh debian/gdb$(TS)/usr/bin/$(TP)gcore
-endif
-
-ifeq ($(build64),yes)
+
+	# Only ship a global gdbinit for the native GDB.
+	install -d debian/gdb$(TS)/etc/gdb
+	install -m 644 debian/gdbinit debian/gdb$(TS)/etc/gdb/
+endif
+
+	rm -f debian/gdb$(TS)/usr/bin/$(TP)gdbtui
+	install -m 755 debian/gdbtui debian/gdb$(TS)/usr/bin/$(TP)gdbtui
+
+binary-post-install/gdb64 ::
 	install -d debian/gdb64/usr/bin
 	install -s -m 755 $(BUILDDIR64)/gdb/gdb debian/gdb64/usr/bin/gdb64
 	dh_link -pgdb64 usr/share/man/man1/gdb.1 usr/share/man/man1/gdb64.1
-endif
-
-	rm -rf debian/tmp/usr/include \
-		debian/tmp/usr/lib/lib*.* \
-		debian/tmp/usr/share/locale
-
-	# Remove the entire info directory; it only contains dummy files,
-	# not the real manuals.
-	rm -rf debian/tmp/usr/share/info
-
-ifneq ($(DEB_CROSS),yes)
-	# libgdb-dev is only required for native GDB.
-	install -d debian/tmp/usr/lib
-	install -m 644 $(DEB_BUILDDIR)/gdb/libgdb.a debian/tmp/usr/lib/
+
+binary-post-install/gdb-minimal ::
+	install -d debian/gdb-minimal/usr/bin
+	$(INSTALL) -m 755 -o root -g root \
+		$(BUILDDIRMIN)/gdb/gdb debian/gdb-minimal/usr/bin/gdb
+
+	$(INSTALL) -m 755 -o root -g root \
+		gdb/gdb_gcore.sh debian/gdb-minimal/usr/bin/gcore
+
+	# Only ship a global gdbinit for the native GDB.
+	install -d debian/gdb-minimal/etc/gdb
+	install -m 644 debian/gdbinit debian/gdb-minimal/etc/gdb/
+
+binary-post-install/libgdb-dev ::
+	install -m 644 $(DEB_BUILDDIR)/gdb/libgdb.a debian/libgdb-dev/usr/lib/
 	if test -e $(DEB_BUILDDIR)/sim/*/libsim.a; then \
-	  install -m 644 $(DEB_BUILDDIR)/sim/*/libsim.a debian/tmp/usr/lib/; \
-	fi
-endif
+	  install -m 644 $(DEB_BUILDDIR)/sim/*/libsim.a debian/libgdb-dev/usr/lib/; \
+	fi
+
+binary-post-install/gdb-source ::
+	install -d debian/gdb-source/usr/src
+	mkdir -p $(BUILDDIRSOURCE)
+	tar --exclude build -cf - . | (cd $(BUILDDIRSOURCE) && tar -xf -)
+	cd $(BUILDDIRSOURCE) && debian/rules clean
+	cd $(dir $(BUILDDIRSOURCE)) \
+	  && tar -cjf $(shell pwd)/debian/gdb-source/usr/src/gdb.tar.bz2 \
+	     $(notdir $(BUILDDIRSOURCE))
 
 debian/control:: debian/control.in $(CROSS_FORCE)
 	cat debian/control.in \
 		| sed "s/@kfreebsd@/`type-handling any kfreebsd`/g" \
 		| sed "s/@gnu@/`type-handling any gnu`/g" \
 		| sed "s/@TS@/$(TS)/g" \
-		> debian/control
-ifeq ($(DEB_CROSS),yes)
-	sed -i "/Package: gdb64/,\$$ d" debian/control
-	cp debian/gdb.install debian/gdb$(TS).install
-endif
-
-DEB_INSTALL_DOCS_gdb$(TS) = gdb/NEWS gdb/README gdb/doc/refcard.tex \
-		objdir/gdb/doc/refcard.dvi objdir/gdb/doc/refcard.ps
-DEB_INSTALL_CHANGELOGS_gdb$(TS) = gdb/ChangeLog
-DEB_INSTALL_MANPAGES_gdb$(TS) = gdb/gdb.1
-ifneq ($(DEB_CROSS),yes)
-DEB_INSTALL_MANPAGES_gdb$(TS) += debian/gcore.1
-endif
-
-DEB_INSTALL_DOCS_libgdb-dev = gdb/NEWS gdb/README
-DEB_INSTALL_CHANGELOGS_libgdb-dev = gdb/ChangeLog
-
-.PHONY: FORCE
-FORCE:
